/*
  Name: Base.h
  Authors: Vlastimil Hopjan, hop007, hopjan@luvasoft.com
           David Pilar,      pil032, pilar.david@seznam.cz
		   Jiri Sovadina,    sov015, ji.so@post.cz
		   Marek Vojtek,     voj086, old-shatterhand@email.cz
  Date: 1.2.2004
  Description: Hlavickovy soubor tridy baze (Base).
*/

#ifndef __Base_h

#define __Base_h

#include "matrix.h"

/** Trida Base je implementaci baze.
  * @version 1.2.2004
 */
class Base {

public:
	Base(void); // Konstruktor tridy Base.
	~Base(void); // Destruktor tridy Base.
	Matrix * createMatrixFromVectors(Matrix ** arrayOfVectors, int vectorsCount); // Z vektoru se vytvori matice a vrati se.
	Matrix * countAverageMatrix(Matrix ** arrayOfMatrix, unsigned int count); // Metoda vypocita prumernou matici z pole matic.
	Matrix * compareMatrixWithBase(Matrix * matrix, char * filename); // Metoda vynasobi (a vrati) na matici (vektor cisel) s vlastnimi vektory.
	void createBaseBeforeR(Matrix **arrayOfVectors, int vectorsCount, char * filename); // Metoda pro vytvoreni baze pred zavolanim programu R-project.
	Matrix * createBaseAfterR(Matrix * matrix, char * filename); // Metoda pro vytvoreni baze po zavolani programu R-project.
	void callR(Matrix * matrix, char * CMFILENAME); // Metoda vytvori soubor vectors.r, ktery se nacte do R-ka.
	void setEigenVectors(Matrix * matrix); // Metoda pro nastaveni matice vlastnich vektoru.
	Matrix * getEigenVectors(void); // Metoda pro ziskani matice vlastnich vektoru.

private:
	Matrix *averageMatrix; // Ukazatel na prumernou matici.
	Matrix *eigenVectors; // Ukazatel na matici vlastnich vektoru.
	Matrix * covariantMatrix; // Ukazatel na kovariacni matici.
	char *CMfilename; // Ukazatel na jmeno souboru s kovariacni matici.
	char *EVfilename; // Ukazatel na jmeno souboru s vlastnimi vektory.
};

#endif // __Base_h
