/*
  Name: BasePerzistency.h
  Authors: Vlastimil Hopjan, hop007, hopjan@luvasoft.com
           David Pilar,      pil032, pilar.david@seznam.cz
		   Jiri Sovadina,    sov015, ji.so@post.cz
		   Marek Vojtek,     voj086, old-shatterhand@email.cz
  Date: 1.2.2004
  Description: Hlavickovy soubor tridy BasePerzistency.
*/

#ifndef __BasePerzistency_h

#define __BasePerzistency_h

#include "base.h"
#include "matrix.h"

/** Trida BasePerzistency implementuje nacitani
  * a ukladani dat potrebnych pro bazi.
  * @version 1.2.2004
 */
class BasePerzistency {

public:
	BasePerzistency(void); // Konstruktor tridy BasePerzistency.
	~BasePerzistency(void); // Destruktor tridy BasePerzistency.
	Base * loadBase(char * filename); // Metoda pro nacteni souboru s vlastnimi vektory, tj. nacte se baze.
	Matrix * loadEigenVectors(char * EVFILENAME); // Metoda pro nacteni vlastnich vektoru ze souboru.
	void saveMatrix(Matrix *matrix, char * CMFILENAME); // Metoda pro ukladani matice do souboru; kazdy provek matice se uklada na novy radek.
	void setCMfilename(char * filename); // Metoda pro nastaveni nazvu souboru kovariancni matice.
	char * getCMfilename(void); // Metoda pro navraceni nazvu souboru kovariancni matice.
	void setEVfilename(char * filename); // Metoda pro nastaveni nazvu souboru s vlastnimi vektory.
	char * getEVfilename(void); // Metoda pro navraceni nazvu souboru s vlastnimi vektory.

private:
	char *CMfilename; // Ukazatel na nazev souboru s kovariancni matici.
	char *EVfilename; // Ukazatel na nazev souboru s vlastnimi vektory.
};

#endif // __BasePerzistency_h
