/*
  Name: CosineMetric.h
  Authors: Vlastimil Hopjan, hop007, hopjan@luvasoft.com
           David Pilar,      pil032, pilar.david@seznam.cz
		   Jiri Sovadina,    sov015, ji.so@post.cz
		   Marek Vojtek,     voj086, old-shatterhand@email.cz
  Date: 1.2.2004
  Description: Hlavickovy soubor pro tridu kosinovy metriky (CosineMetric).
*/

#ifndef __CosineMetric_h

#define __CosineMetric_h

#include "metric.h"

/** Trida CosineMetric implementuje kosinovu metriku.
  * Trida implementuje abstraktni tridu Metric.
  * @version 1.2.2004
 */
class CosineMetric :
	public Metric {

public:
	CosineMetric(void); // Konstruktor tridy CosineMetric.
	~CosineMetric(void); // Destruktor tridy CosineMetric.
	double getDistance(Matrix *matrixA, Matrix *matrixB); // Metoda, ktera slouzi pro vypocet kosinove metriky.
	unsigned int getId(void); // Metoda vrati ID metriky.

private:
	unsigned int id; // id metriky
};

#endif // __CosineMetric_h
