/*
  Name: Database.h
  Authors: Vlastimil Hopjan, hop007, hopjan@luvasoft.com
           David Pilar,      pil032, pilar.david@seznam.cz
		   Jiri Sovadina,    sov015, ji.so@post.cz
		   Marek Vojtek,     voj086, old-shatterhand@email.cz
  Date: 1.2.2004
  Description: Hlavickovy soubor pro tridu databaze (Database).
*/

#ifndef __Database_h

#define __Database_h

#include "matrix.h"
#include "metric.h"

/** Trida Database uklada matice do pameti a vybyra podobne matice.
  * @version 1.2.2004
 */
class Database {

public:
	Database(); // Konstruktor tridy Database.
	~Database(void); // Destruktor tridy Database.
	void addMatrix(Matrix *matrix); // Metoda, ktera prida do pole matic dalsi matici typu Matix.
	void removeMatrix(Matrix *matrix); // Metoda, ktera odebere matici z pole matic.
	Matrix ** selectMatrix(Matrix *matrix, float trashold, unsigned int &count); // Metoda, ktera vybere podobne matice z pole matic.
	void setMetric(Metric *metric); // Metoda pro nastaveni pouzivane metriky.
	unsigned int getCountValues(void); // Metoda, ktera vrati pocet matic v poli.
	int getMetricId(void); // Metoda, ktera vraci ID metriky.
	Matrix * getMatrix(unsigned int position); // Metoda, ktera vraci ukazatel na matici podle zadane pozice.

private:
	Matrix *matrixValues; // Pole matic v pameti.
	unsigned int countValues; // Pocet matic v poli.
	Metric *metric; // Ukazatel na metriku, podle ktere se vybiraji podobne matice z pole.
};

#endif // __Database_h
