/*
  Name: DatabasePerzistency.h
  Authors: Vlastimil Hopjan, hop007, hopjan@luvasoft.com
           David Pilar,      pil032, pilar.david@seznam.cz
		   Jiri Sovadina,    sov015, ji.so@post.cz
		   Marek Vojtek,     voj086, old-shatterhand@email.cz
  Date: 1.2.2004
  Description: Hlavickovy soubor pro tridu DatabasePerzistency.
*/

#ifndef __DatabasePerzistency_h

#define __DatabasePerzistency_h

#include "database.h"
#include "euclidsmetric.h"
#include "cosinemetric.h"

/** Trida DatabasePerzistency se stara o ukladani a nahravani databaze
  * matic typu Matrix z/do pameti.
  * @version 1.2.2004
 */
class DatabasePerzistency {

public:
	DatabasePerzistency(char *fileName); // Konstruktor tridy DatabasePerzistency.
	~DatabasePerzistency(void); // Destruktor tridy DatabasePerzistency.
	void saveDatabase(Database *database); // Metoda slouzici pro ulozeni database do souboru.
	Database * loadDatabase(void); // Metoda slouzici pro nacteni databaze ze souboru.

private:
	char *fileName; // Ukazatel na nazev souboru, z/do ktereho je databaze nahravana/ukladana.
};

#endif // __DatabasePerzistency_h
