/*
  Name: EuclidsMetric.h
  Authors: Vlastimil Hopjan, hop007, hopjan@luvasoft.com
           David Pilar,      pil032, pilar.david@seznam.cz
		   Jiri Sovadina,    sov015, ji.so@post.cz
		   Marek Vojtek,     voj086, old-shatterhand@email.cz
  Date: 1.2.2004
  Description: Hlavickovy soubor pro tridu eklidovy metriky (EuclidsMetric).
*/

#ifndef __EuclidsMetric_h

#define __EuclidsMetric_h

#include "metric.h"

/** Trida CosineMetric implementuje euklidovu metriku.
  * Trida implementuje abstraktni tridu Metric.
  * @version 1.2.2004
 */
class EuclidsMetric :
	public Metric {

public:
	EuclidsMetric(void); // Konstruktor tridy EuclidsMetric.
	~EuclidsMetric(void); // Destruktor tridy EuclidsMetric.
	double getDistance(Matrix *matrixA, Matrix *matrixB); // Metoda, ktera slouzi pro vypocet euklidovy metriky.
	unsigned int getId(void); // Metoda vrati ID metriky.

private:
	unsigned int id; // id metriky
};

#endif // __EuclidsMetric_h
