/*
  Name: Matrix.h
  Authors: Vlastimil Hopjan, hop007, hopjan@luvasoft.com
           David Pilar,      pil032, pilar.david@seznam.cz
		   Jiri Sovadina,    sov015, ji.so@post.cz
		   Marek Vojtek,     voj086, old-shatterhand@email.cz
  Date: 1.2.2004
  Description: Hlavickovy soubor pro tridu matice (Matrix).
*/

#ifndef __Matrix_h

#define __Matrix_h

/** Trida Matrix je implementaci matice.
  * @version 1.2.2004
 */
class Matrix {

public:
	Matrix(void); // Konstruktor tridy Matrix.
	~Matrix(void); // Destruktor tridy Matrix.
	unsigned int getColumns(void); // Metoda, ktera vraci pocet sloupcu matice.
	unsigned int getRows(void); // Metoda, ktera vraci pocet radku matice.
	void setColumns(unsigned int columns); // Metoda, ktera nastavi pocet sloupcu matice.
	void setRows(unsigned int rows); // Metoda, ktera nastavi pocet radku matice.
	char * getFileName(void); // Metoda, ktera vraci ukazatel na nazev souboru, ve kterem je ulozen puvodni obrazek.
	void setFileName(char * fileName); // Metoda, ktera nastavi ukazatel na nazev souboru, ve kterem je ulozen puvodni obrazek.
	void setCoordinateAt(unsigned int row, unsigned int column, double value); // Metoda pro ulozeni hodnoty v matici na prislusne misto.
	double getCoordinateAt(unsigned int row, unsigned int column); // Metoda pro vybrani hodnoty z prislusneho mista v matici.
	void add(Matrix *matrix); // Metoda, ktera pricte k jedne matici matici druhou.
	void multiply(double scalar); // Metoda pro vynasobeni matice skalarem.
	void multiply(Matrix *matrix); // Metoda pro vynasobeni matice matici.
	void transpose(void); // Metoda pro transponovani matice.
	void resample(void); // Metoda pro prevzorkovani obrazku ulozeneho v matici.
	void print(void); // Metoda, ktera vytiskne matici na obrazovku.
	void normalize(void); // Metoda k normovani vektoru.
	Matrix * getAsVector(void); // Metoda, ktera vrati viceradkovou jako jednoradkovou matici (tzn. vektor).

private:
	unsigned int columns; // pocet sloupcu
	unsigned int rows; // pocet radku
	char * fileName; // ukazatel na nazev souboru s obrazkem
	double ** matrixValues; // privatni promenna pro uchovavani hodnot
	unsigned int allocateMatrix(void); // Metoda, ktera alokuje pamet pro matici, pripadne pamet realokuje.
};

#endif // __Matrix_h
