/*
  Name: Metric.h
  Authors: Vlastimil Hopjan, hop007, hopjan@luvasoft.com
           David Pilar,      pil032, pilar.david@seznam.cz
		   Jiri Sovadina,    sov015, ji.so@post.cz
		   Marek Vojtek,     voj086, old-shatterhand@email.cz
  Date: 1.2.2004
  Description: Hlavickovy soubor abstraktni tridy / interfacu pro tridu metrika (Metric).
*/

#ifndef __Metric_h

#define __Metric_h

#include "matrix.h"

/** Abstractni trida / interface pro metriky.
  * @version 1.2.2004
 */
class Metric {

public:
	virtual double getDistance(Matrix *matrixA, Matrix *matrixB) = 0;// Metoda, ktera slouzi pro vypocet metriky.
	virtual unsigned int getId(void) = 0; // Metoda vrati ID metriky.
};

#endif // __Metric_h
