/*
  Name: PictureReader.cpp
  Authors: Vlastimil Hopjan, hop007, hopjan@luvasoft.com
           David Pilar,      pil032, pilar.david@seznam.cz
		   Jiri Sovadina,    sov015, ji.so@post.cz
		   Marek Vojtek,     voj086, old-shatterhand@email.cz
  Date: 1.2.2004
  Description: Implementace tridy pro nacitani obrazku ze souboru (PictureReader).
*/

#include ".\picturereader.h"
#include ".\matrix.h"

#include <stdio.h>
#include <stdlib.h>
#include <iostream>

using namespace std;

/** Konstruktor tridy PictureReader.
  * @version 1.2.2004
  *
  * @acces public
  * @param void
  * @return void
 */
PictureReader::PictureReader() {
}
/** Destruktor tridy PictureReader.
  * @version 1.2.2004
  *
  * @acces public
  * @param void
  * @return void
 */
PictureReader::~PictureReader() {
}
/** Metoda, ktera nacte obrazek ze souboru, ulozi jej do matice
  * a vrati ukazetel na matici.
  * @version 1.2.2004
  *
  * @acces public
  * @param *filename -> ukazatel na soubor, kde je ulozen obrazek
  * @return Matrix* -> ukazatel na matici s nactenym obrazkem
 */
Matrix * PictureReader::readPictureFromFile(char *fileName) {

	Matrix *m = NULL;
	FILE *file;

	if ((file = fopen(fileName, "rb")) != NULL) {

		unsigned int rows, columns, colors;
		unsigned char c;

		fscanf(file, "%c", &c);
		if (c != 'P') {
			cerr << "CHYBA (PictureReader::readPictureFromFile): Soubor neodpovida specifikaci." << endl;
			exit(1);
		} // end if
		fscanf(file, "%c\n", &c);
		if (c != '5') {
			cerr << "CHYBA (PictureReader::readPictureFromFile): Soubor neodpovida specifikaci." << endl;
			exit(1);
		} // end if

		m = new Matrix();

		fscanf(file, "%i %i\n", &columns, &rows);
		fscanf(file, "%i\n", &colors);

		m -> setFileName(fileName);
		m -> setRows(rows);
		m -> setColumns(columns);

		for(unsigned int i = 0; i < columns; i++) {
			for(unsigned int j = 0; j < rows; j++) {
				fscanf(file, "%c", &c);
				m -> setCoordinateAt(j, i, (float)c);
			} // end for
		} // end for

		fclose(file);

		// prevzorkovani obrazku
        //cout << "pred prevzorkovanim" << endl;
        //m->print();

        m -> resample();
        //cout << "po prevzorkovanim" << endl;
        //m->print();

	} else {
		cerr << "CHYBA (PictureReader::readPictureFromFile): Nepodarilo se otevrit soubor s obrazkem pro cteni." << endl;
		exit(1);
	}

    return m;	
}
