/*
  Name: UserInterface.h
  Authors: Vlastimil Hopjan, hop007, hopjan@luvasoft.com
           David Pilar,      pil032, pilar.david@seznam.cz
		   Jiri Sovadina,    sov015, ji.so@post.cz
		   Marek Vojtek,     voj086, old-shatterhand@email.cz
  Date: 1.2.2004
  Description: Hlavickovy soubor pro tridu uzivatelske rozhrani (UserInterface).
*/

#ifndef __UserInterface_h

#define __UserInterface_h

#include "picturereader.h"
#include "databaseperzistency.h"
#include "baseperzistency.h"
#include "database.h"
#include "base.h"

/** Trida UserInterface je implementaci uzivatelskeho rozhrani prikazove radky.
  * @version 1.2.2004
 */
class UserInterface {

public:
	UserInterface(int argCount, char *argValues[]); // Konstruktor tridy UserInterface.
	~UserInterface(); // Destruktor tridy UserInterface.
	void printHelp(void); // Metoda pro vypis napovedy.
	void execute(void); // Metoda pro vykonani programu.

private:
	int argCount; // Pocet argumentu.
	char **argValues; // Hodnoty argumentu.
	char *pictureName; // Jmeno souboru.
	PictureReader * m_pr; // Ukazatel na tridu PictureReader.
	DatabasePerzistency *dbp; // Ukazatel na tridu DatabasePerzistency.
    BasePerzistency *m_bp; // Ukazatel na tridu BasePerzistency.
	Database *db; // // Ukazatel na tridu Database.
	Base *b; // // Ukazatel na tridu Base.
	bool isSwitch(char*); // Metoda pro urceni, zda je dany argument prepinac.
};

#endif // __UserInterface_h
